<?php
namespace Teknisa\COZ\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class Pla08200 extends \Zeedhi\Framework\Controller\Report {

    protected $requisicaoPlanejamentoProducaoService;
    protected $previsaoConsumoCentralService;
    protected $entityManager;
    protected $birtStrategy;
    protected $reportName;
    protected $nrorg;
    protected $nrlista;
    protected $nrconsplan;
    protected $produtos;
    protected $pla08200Service;

    public function __construct(ReportService $reportService, $entityManager, $birtStrategy, $requisicaoPlanejamentoProducaoService, $previsaoConsumoCentralService, $pla08200Service) {
        $this->requisicaoPlanejamentoProducaoService = $requisicaoPlanejamentoProducaoService;
        $this->previsaoConsumoCentralService = $previsaoConsumoCentralService;
        $this->entityManager = $entityManager;
        $this->birtStrategy       = $birtStrategy;
        $this->pla08200Service = $pla08200Service;
 
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'prev08200' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTINICIAL' => 'P_DTINICIAL',
                        'DTFINAL' => 'P_DTFINAL',
                        'CDCENTRAL' => 'P_CDCENTFILI',
                        'NRORG' => 'P_NRORG',
                        'TAMACNIVEL' => 'P_TAMACNIVEL',
                        'TAMCODIGO' => 'P_TAMCODIGO',
                        'PRODINI' => 'P_CDPRODINI',
                        'PRODFIN' => 'P_CDPRODFIN',
                        'IDSUBGRUP' => 'P_IDSUBGRUP',
                        'CDGRUPPROD' => 'P_CDGRUPPROD',
                        'LISTAGRUPPROD' => 'P_LISTASUBGRUP',
                        'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                        'CDPICTPROD' => 'P_CDPICTPROD',
                        'IMPRIMIRFILTRO' => 'P_IMPRIMIRFILTRO'
                    )
            ),
        'prev08201' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTINICIAL' => 'P_DTINICIAL',
                        'DTFINAL' => 'P_DTFINAL',
                        'NMTIPOCUSTO' => 'P_TIPOCUSTO',
                        'CDTIPOCUSTO' => 'P_NRTIPOCUST',
                        'CDCENTRAL' => 'P_CDCENTFILI',
                        'NRORG' => 'P_NRORG',
                        'TAMACNIVEL' => 'P_TAMACNIVEL',
                        'TAMCODIGO' => 'P_TAMCODIGO',
                        'PRODINI' => 'P_CDPRODINI',
                        'PRODFIN' => 'P_CDPRODFIN',
                        'IDSUBGRUP' => 'P_IDSUBGRUP',
                        'CDGRUPPROD' => 'P_CDGRUPPROD',
                        'LISTAGRUPPROD' => 'P_LISTASUBGRUP',
                        'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                        'CDPICTPROD' => 'P_CDPICTPROD',
                        'IMPRIMIRFILTRO' => 'P_IMPRIMIRFILTRO'
                    )
            ),
        'prev08202' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTINICIAL' => 'P_DTINICIAL',
                        'DTFINAL' => 'P_DTFINAL',
                        'TIPONIVEL' => 'P_TIPONIVEL',
                        'NMTIPOCUSTO' => 'P_TIPOCUSTO',
                        'CDCENTRAL' => 'P_CDCENTFILI',
                        'NRORG' => 'P_NRORG',
                        'TAMACNIVEL' => 'P_TAMACNIVEL',
                        'TAMCODIGO' => 'P_TAMCODIGO',
                        'PRODINI' => 'P_CDPRODINI',
                        'PRODFIN' => 'P_CDPRODFIN',
                        'NRCONSPLAN' => 'P_NRCONSPLAN',
                        'NRLISTASERVICO' => 'P_SERVICO1',
                        'DTCARDAFIN' => 'P_DTFINALLIM',
                        'IDSUBGRUP' => 'P_IDSUBGRUP',
                        'CDGRUPPROD' => 'P_CDGRUPPROD',
                        'LISTAGRUPPROD' => 'P_LISTASUBGRUP',
                        'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                        'CDPICTPROD' => 'P_CDPICTPROD',
                        'IMPRIMIRFILTRO' => 'P_IMPRIMIRFILTRO'
                    )
            ),
        'prev08203' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTINICIAL' => 'P_DTINICIAL',
                        'DTFINAL' => 'P_DTFINAL',
                        'CDCENTRAL' => 'P_CDCENTFILI',
                        'NRORG' => 'P_NRORG',
                        'TAMACNIVEL' => 'P_TAMACNIVEL',
                        'TAMCODIGO' => 'P_TAMCODIGO',
                        'IDSUBGRUP' => 'P_IDSUBGRUP',
                        'PRODINI' => 'P_CDPRODINI',
                        'PRODFIN' => 'P_CDPRODFIN',
                        'CDGRUPPROD' => 'P_CDGRUPPROD',
                        'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                        'LISTAGRUPPROD' => 'P_LISTASUBGRUP',
                        'CDPICTPROD' => 'P_CDPICTPROD',
                        'IMPRIMIRFILTRO' => 'P_IMPRIMIRFILTRO'
                    )
            ),
        'prev08204' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTINICIAL' => 'P_DTINICIAL',
                        'DTFINAL' => 'P_DTFINAL',
                        'TIPONIVEL' => 'P_TIPONIVEL',
                        'NMTIPOCUSTO' => 'P_TIPOCUSTO',
                        'CDCENTRAL' => 'P_CDCENTFILI',
                        'NRORG' => 'P_NRORG',
                        'TAMACNIVEL' => 'P_TAMACNIVEL',
                        'CDTIPOCUSTO' => 'P_NRTIPOCUST',
                        'TAMCODIGO' => 'P_TAMCODIGO',
                        'IDSUBGRUP' => 'P_IDSUBGRUP',
                        'PRODINI' => 'P_CDPRODINI',
                        'PRODFIN' => 'P_CDPRODFIN',
                        'CDGRUPPROD' => 'P_CDGRUPPROD',
                        'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                        'LISTAGRUPPROD' => 'P_LISTASUBGRUP',
                        'CDPICTPROD' => 'P_CDPICTPROD',
                        'IMPRIMIRFILTRO' => 'P_IMPRIMIRFILTRO'
                    )
            ),
        'prev08205' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTINICIAL' => 'P_DTINICIAL',
                        'DTFINAL' => 'P_DTFINAL',
                        'CDCENTRAL' => 'P_CDCENTFILI',
                        'NRORG' => 'P_NRORG',
                        'TAMACNIVEL' => 'P_TAMACNIVEL',
                        'TAMCODIGO' => 'P_TAMCODIGO',
                        'PRODINI' => 'P_CDPRODINI',
                        'PRODFIN' => 'P_CDPRODFIN',
                        'NRCONSPLAN' => 'P_NRCONSPLAN',
                        'NRLISTASERVICO' => 'P_SERVICO1',
                        'DTCARDAFIN' => 'P_DTFINALLIM',
                        'IDSUBGRUP' => 'P_IDSUBGRUP',
                        'CDGRUPPROD' => 'P_CDGRUPPROD',
                        'LISTAGRUPPROD' => 'P_LISTASUBGRUP',
                        'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                        'CDPICTPROD' => 'P_CDPICTPROD',
                        'IMPRIMIRFILTRO' => 'P_IMPRIMIRFILTRO'
                    )
            ),
        'prev08206' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDCENTRAL' => 'P_CDCENTFILI',
                        'TAMACNIVEL' => 'P_TAMACNIVEL',
                        'TAMCODIGO' => 'P_TAMCODIGO',
                        'DTINICIAL' => 'P_DTINICIAL',
                        'DTFINAL' => 'P_DTFINAL',
                        'PRODINI' => 'P_CDPRODINI',
                        'PRODFIN' => 'P_CDPRODFIN',
                        'NRORG' => 'P_NRORG',
                        'NRLISTASERVICO' => 'P_SERVICO1',
                        'IDSUBGRUP' => 'P_IDSUBGRUP',
                        'CDGRUPPROD' => 'P_CDGRUPPROD',
                        'LISTAGRUPPROD' => 'P_LISTASUBGRUP',
                        'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                        'CDPICTPROD' => 'P_CDPICTPROD',
                        'IMPRIMIRFILTRO' => 'P_IMPRIMIRFILTRO'
                    )
            ),
        'prev08207' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDCENTRAL' => 'P_CDCENTFILI',
                        'TAMACNIVEL' => 'P_TAMACNIVEL',
                        'TAMCODIGO' => 'P_TAMCODIGO',
                        'DTINICIAL' => 'P_DTINICIAL',
                        'DTFINAL' => 'P_DTFINAL',
                        'PRODINI' => 'P_CDPRODINI',
                        'PRODFIN' => 'P_CDPRODFIN',
                        'NRORG' => 'P_NRORG',
                        'NMTIPOCUSTO' => 'P_TIPOCUSTO',
                        'CDTIPOCUSTO' => 'P_NRTIPOCUST',
                        'NRLISTASERVICO' => 'P_SERVICO1',
                        'IDSUBGRUP' => 'P_IDSUBGRUP',
                        'CDGRUPPROD' => 'P_CDGRUPPROD',
                        'LISTAGRUPPROD' => 'P_LISTASUBGRUP',
                        'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                        'CDPICTPROD' => 'P_CDPICTPROD',
                        'IMPRIMIRFILTRO' => 'P_IMPRIMIRFILTRO'
                    )
            ),
        'prev08211' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDCENTRAL' => 'P_CDCENTFILI',
                        'TAMACNIVEL' => 'P_TAMACNIVEL',
                        'TAMCODIGO' => 'P_TAMCODIGO',
                        'ORDENA' => 'P_ORDENA',
                        'DTINICIAL' => 'P_DTINICIAL',
                        'DTFINAL' => 'P_DTFINAL',
                        'PRODINI' => 'P_CDPRODINI',
                        'PRODFIN' => 'P_CDPRODFIN',
                        'NRORG' => 'P_NRORG',
                        'NRLISTASERVICO' => 'P_SERVICO1',
                        'IDSUBGRUP' => 'P_IDSUBGRUP',
                        'CDGRUPPROD' => 'P_CDGRUPPROD',
                        'LISTAGRUPPROD' => 'P_LISTASUBGRUP',
                        'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                        'CDPICTPROD' => 'P_CDPICTPROD',
                        'IMPRIMIRFILTRO' => 'P_IMPRIMIRFILTRO'
                    )
            ),
        'prev00812' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTINICIAL' => 'P_DTINICIAL',
                        'DTFINAL' => 'P_DTFINAL',
                        'CDCENTRAL' => 'P_CDCENTFILI',
                        'TAMACNIVEL' => 'P_TAMACNIVEL',
                        'TAMCODIGO' => 'P_TAMCODIGO',
                        'DTCARDAFIN' => 'P_DTFINALLIM',
                        'NRLISTASERVICO' => 'P_SERVICO1',
                        'NRORG' => 'P_NRORG',
                        'IDSUBGRUP' => 'P_IDSUBGRUP',
                        'CDGRUPPROD' => 'P_CDGRUPPROD',
                        'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                        'LISTAGRUPPROD' => 'P_LISTASUBGRUP',
                        'NRCONSPLAN' => 'P_NRCONSPLAN',						
                        'PRODINI' => 'P_CDPRODINI',
                        'PRODFIN' => 'P_CDPRODFIN',
                        'CDPICTPROD' => 'P_CDPICTPROD',
                        'IMPRIMIRFILTRO' => 'P_IMPRIMIRFILTRO'
                    )
            ),
        'prev00813' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTINICIAL' => 'P_DTINICIAL',
                        'DTFINAL' => 'P_DTFINAL',
                        'CDCENTRAL' => 'P_CDCENTFILI',
                        'TAMACNIVEL' => 'P_TAMACNIVEL',
                        'TAMCODIGO' => 'P_TAMCODIGO',
                        'DTCARDAFIN' => 'P_DTFINALLIM',
                        'NRLISTASERVICO' => 'P_SERVICO1',
                        'NRORG' => 'P_NRORG',
                        'IDSUBGRUP' => 'P_IDSUBGRUP',
                        'CDGRUPPROD' => 'P_CDGRUPPROD',
                        'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                        'LISTAGRUPPROD' => 'P_LISTASUBGRUP',
                        'NRCONSPLAN' => 'P_NRCONSPLAN',
                        'PRODINI' => 'P_CDPRODINI',
                        'PRODFIN' => 'P_CDPRODFIN',
                        'CDPICTPROD' => 'P_CDPICTPROD',
                        'CDPICTPRAT' => 'P_CDPICTPRAT',
                        'IMPRIMIRFILTRO' => 'P_IMPRIMIRFILTRO'
                    )
            ),
        'prev08208' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTINICIAL' => 'P_DTINICIAL',
                        'DTFINAL' => 'P_DTFINAL',
                        'TIPONIVEL' => 'P_TIPONIVEL',
                        'NMTIPOCUSTO' => 'P_TIPOCUSTO',
                        'CDCENTRAL' => 'P_CDCENTFILI',
                        'TAMACNIVEL' => 'P_TAMACNIVEL',
                        'TAMCODIGO' => 'P_TAMCODIGO',
                        'NRLISTASERVICO' => 'P_SERVICO1',
                        'NRORG' => 'P_NRORG',
                        'IDSUBGRUP' => 'P_IDSUBGRUP',
                        'CDGRUPPROD' => 'P_CDGRUPPROD',
                        'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                        'LISTAGRUPPROD' => 'P_LISTASUBGRUP',
                        'NRCONSPLAN' => 'P_NRCONSPLAN',
                        'PRODINI' => 'P_CDPRODINI',
                        'PRODFIN' => 'P_CDPRODFIN',
                        'CDPICTPROD' => 'P_CDPICTPROD',
                        'IMPRIMIRFILTRO' => 'P_IMPRIMIRFILTRO'
                    )
            ),
        'prev08209' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTINICIAL' => 'P_DTINICIAL',
                        'DTFINAL' => 'P_DTFINAL',
                        'LISTASERVICO' => 'P_CDSERVICO',
                        'CDCENTRAL' => 'P_CDCENTFILI',
                        'TAMACNIVEL' => 'P_TAMACNIVEL',
                        'TAMCODIGO' => 'P_TAMCODIGO',
                        'NRLISTASERVICO' => 'P_SERVICO1',
                        'NRORG' => 'P_NRORG',
                        'IDSUBGRUP' => 'P_IDSUBGRUP',
                        'CDGRUPPROD' => 'P_CDGRUPPROD',
                        'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                        'LISTAGRUPPROD' => 'P_LISTASUBGRUP',
                        'NRCONSPLAN' => 'P_NRCONSPLAN',
                        'PRODINI' => 'P_CDPRODINI',
                        'PRODFIN' => 'P_CDPRODFIN',
                        'CDPICTPROD' => 'P_CDPICTPROD',
                        'IMPRIMIRFILTRO' => 'P_IMPRIMIRFILTRO'
                    )
            )
    );


    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $this->reportName = $row['CD_REPORT_NAME'];
        $this->nrorg = $row['NRORG'];
        
        $row['CDGRUPFILI'] = ($row['CDGRUPFILI'] === '' ? 'T' : $row['CDGRUPFILI']);

        $row["LISTAFILIAL"]   = $this->pla08200Service->retornaFiliais((array)$row);
        $row["LISTAGRUPSERV"] = $this->pla08200Service->retornaGrupServ((array)$row);
        $row['LISTASERVICO']  = $this->pla08200Service->retornaServico((array)$row);

        $listaservico  = $row["LISTASERVICO"];
        
        if($this->reportName != 'prev08200' || $this->reportName != 'prev08201' || $this->reportName != 'prev08203' || $this->reportName != 'prev08204') {
            $this->nrlista = $this->requisicaoPlanejamentoProducaoService->geraLista($this->nrorg, $listaservico, '_');
            $row['NRLISTASERVICO'] = $this->nrlista;
		}
		
        $dtinicial = $row['DTINICIAL'];
        $dtfinal   = $row['DTFINAL'];
        $cdprodini = $row['PRODINI'];
        $cdprodfin = $row['PRODFIN'];
        $this->produtos = 'XFP';
        $row['DTCARDAFIN'] = $row['DTFINAL'];
        $row['DTCARDAFIN'] = $this->pla08200Service->retornaDataFinal(array($row));
        
        if($this->reportName == 'prev08202' || $this->reportName == 'prev08205' || $this->reportName == 'prev00812' || 
		   $this->reportName == 'prev08208' || $this->reportName == 'prev08209' || $this->reportName == 'prev00813'
		) {
            $nrlistaprocedure = $this->requisicaoPlanejamentoProducaoService->geraLista($this->nrorg, $listaservico, '_');
            $nrconsplan = $this->previsaoConsumoCentralService->procedureConsplanGeral($nrlistaprocedure, $dtinicial, $dtfinal, $cdprodini, $cdprodfin, $this->produtos);
            $row['NRCONSPLAN'] = $nrconsplan['P_NRCONSPLAN'];
            $this->nrconsplan  = $row['NRCONSPLAN'];
        } else {
            $this->nrconsplan = null;
        }
        
        if($row['LISTASERVICO'] == null) $row['LISTASERVICO'] = 'x';
        
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    }

    public function afterProcessReport(DTO\Request\Row $request, DTO\Response $response, $report) {
//         $this->requisicaoPlanejamentoProducaoService->deletaLista($this->nrorg, $this->nrlista);
//         if($this->reportName == 'prev08202' || $this->reportName == 'prev08205' || $this->reportName == 'prev00812' || 
// 		   $this->reportName == 'prev08208' || $this->reportName == 'prev08209'
// 		) {
//             $this->previsaoConsumoCentralService->deletaConsplan($this->nrorg, $this->nrconsplan);
//         }
    }
}